package Form;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Blob;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.sql.rowset.serial.SerialBlob;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;
import org.apache.commons.io.IOUtils;
import shared.Message;
import shared.Plat;

public class UpdatePlat_Form extends javax.swing.JInternalFrame {

    public MainApp parentMainApp;
    static public DefaultTableModel   table = null;
    
    public UpdatePlat_Form(MainApp parent) {
        
        parentMainApp = parent;
        parentMainApp.cuisinier.send(new Message("ListPlat", parentMainApp.cuisinier.getUsername(), "SendMeTheListOfPlat", "SERVER"));
        parentMainApp.cuisinier.setGui_ListPlat(this);
        if(table != null) initComponents();
    }


    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Image_jButton = new javax.swing.JButton();
        Categorie_jComboBox = new javax.swing.JComboBox();
        Categorie_jLabel = new javax.swing.JLabel();
        Nom_jLabel = new javax.swing.JLabel();
        Modifier_jButton = new javax.swing.JButton();
        Supprimer_jButton = new javax.swing.JButton();
        Image_jTextField = new javax.swing.JTextField();
        Image_jPanel = new javax.swing.JPanel();
        BX = new javax.swing.JLabel();
        duree_jLabel = new javax.swing.JLabel();
        duree_jTextField = new javax.swing.JTextField();
        Prix_jLabel = new javax.swing.JLabel();
        Prix_jTextField = new javax.swing.JTextField();
        Title_jLabel = new javax.swing.JLabel();
        Nom_jTextField = new javax.swing.JTextField();
        Image_jLabel = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        Data_jTable = new javax.swing.JTable(table);

        setBackground(new java.awt.Color(191, 205, 219));
        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Update/Delete Plat");

        Image_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jButton.setText("Parcourir");
        Image_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Image_jButtonActionPerformed(evt);
            }
        });

        Categorie_jComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" }));

        Categorie_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Categorie_jLabel.setText("Categorie Plat :");

        Nom_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Nom_jLabel.setText("Nom Plat :");

        Modifier_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Modifier_jButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/edit.png"))); // NOI18N
        Modifier_jButton.setText("Modifier");
        Modifier_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Modifier_jButtonActionPerformed(evt);
            }
        });

        Supprimer_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Supprimer_jButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/delete.png"))); // NOI18N
        Supprimer_jButton.setText("Supprimer");
        Supprimer_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Supprimer_jButtonActionPerformed(evt);
            }
        });

        Image_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Image du Plat"));

        javax.swing.GroupLayout Image_jPanelLayout = new javax.swing.GroupLayout(Image_jPanel);
        Image_jPanel.setLayout(Image_jPanelLayout);
        Image_jPanelLayout.setHorizontalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Image_jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BX, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(22, Short.MAX_VALUE))
        );
        Image_jPanelLayout.setVerticalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(BX, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        duree_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        duree_jLabel.setText("Durée Préparation :");

        Prix_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Prix_jLabel.setText("Prix du Plat :");

        Title_jLabel.setFont(new java.awt.Font("Tahoma", 3, 20)); // NOI18N
        Title_jLabel.setText("Liste Des Plats");

        Image_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jLabel.setText("Image du Plat :");

        Data_jTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                Data_jTableMouseClicked(evt);
            }
        });
        Data_jTable.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                Data_jTableKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(Data_jTable);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(200, 200, 200)
                        .addComponent(Title_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(26, 26, 26)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                        .addComponent(Nom_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                        .addComponent(Categorie_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE))
                                    .addComponent(Prix_jLabel)
                                    .addComponent(duree_jLabel)
                                    .addComponent(Image_jLabel))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(Image_jButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Prix_jTextField)
                                    .addComponent(duree_jTextField)
                                    .addComponent(Image_jTextField)
                                    .addComponent(Categorie_jComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Nom_jTextField))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(Image_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(18, 18, 18))
                            .addGroup(layout.createSequentialGroup()
                                .addContainerGap()
                                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 617, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(Modifier_jButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Supprimer_jButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(Title_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(20, 20, 20)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 170, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Modifier_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(Supprimer_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 69, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Categorie_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Categorie_jLabel))
                        .addGap(7, 7, 7)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Nom_jLabel)
                            .addComponent(Nom_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Prix_jLabel)
                            .addComponent(Prix_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(duree_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(duree_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Image_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(Image_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 38, Short.MAX_VALUE))
                    .addComponent(Image_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void Image_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Image_jButtonActionPerformed

        BufferedImage image;

        try{
            FileNameExtensionFilter filter = new FileNameExtensionFilter("Image file only", "jpg", "jpeg","bmp","png");
            fileChooser = new JFileChooser();
            fileChooser.setCurrentDirectory(new File(Selected_FilePath));
            fileChooser.setSelectedFile(new File(Selected_nom_image));
            fileChooser.setFileFilter(filter);
            fileChooser.setAcceptAllFileFilterUsed(false);

            int returnValue = fileChooser.showDialog(this, "Choisir Image du Plat");

            if (returnValue == JFileChooser.APPROVE_OPTION)
            {

                Selected_File=fileChooser.getSelectedFile();
                Selected_nom_image = Selected_File.getName();
                Selected_bytes = new byte[(int) Selected_File.length()];
                
                try {
                        //convert file into array of bytes
                        FileInputStream fileInputStream=null;
                        fileInputStream = new FileInputStream(Selected_File);
                        fileInputStream.read(Selected_bytes);
                        fileInputStream.close();
                    }catch(Exception e){
                        System.out.println("blob");
                    }
                Selected_image = new SerialBlob(Selected_bytes);
                
                image=ImageIO.read(Selected_File);
                ImageIcon icon;
                icon = new ImageIcon(image);

                Image img = icon.getImage();
                BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_ARGB);
                Graphics g = bi.createGraphics();
                g.drawImage(img, 0, 0, 230, 250, null);
                ImageIcon newIcon = new ImageIcon(bi);

                BX.setIcon(newIcon);

                if(Selected_File != null)
                {

                    Selected_FilePath = Selected_File.getPath();
                    if(ArchOS){ Selected_FilePath = Selected_FilePath.replace("\\", "/"); }
                    Image_jTextField.setText(Selected_FilePath);
                }
                    
                    
                }

            }catch(Exception e){System.out.println(e);}
    }//GEN-LAST:event_Image_jButtonActionPerformed

    private void Modifier_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Modifier_jButtonActionPerformed
        
        try {

            String Categorie_String = (String)Categorie_jComboBox.getSelectedItem();
            String Nom_String = Nom_jTextField.getText();
            double Prix_Double = Double.parseDouble(Prix_jTextField.getText());
            int duree_int = Integer.parseInt(duree_jTextField.getText());

            Plat New_Plat = new Plat(Categorie_String, Nom_String, Prix_Double, duree_int, Selected_nom_image, Selected_image);
            parentMainApp.cuisinier.send(new Message("ModifierPlat", parentMainApp.cuisinier.getUsername(), "EnvoieModifPlat", "SERVER",Selected_Plat,New_Plat));
            
            Data_jTable.getSelectionModel().clearSelection();
            
            Categorie_jComboBox.setSelectedIndex(0);
            Nom_jTextField.setText("");
            Prix_jTextField.setText("");
            duree_jTextField.setText("");
            Image_jTextField.setText("");
            BX.setIcon(null);
            
            
        }catch(Exception ex){
            ex.printStackTrace();
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Erreur", JOptionPane.ERROR_MESSAGE);
        }
        
        
    }//GEN-LAST:event_Modifier_jButtonActionPerformed

    private void Data_jTableKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_Data_jTableKeyPressed
        SelectAction();
    }//GEN-LAST:event_Data_jTableKeyPressed

    private void Data_jTableMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_Data_jTableMouseClicked
        SelectAction();
    }//GEN-LAST:event_Data_jTableMouseClicked

    private void Supprimer_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Supprimer_jButtonActionPerformed
        
        try {
            parentMainApp.cuisinier.send(new Message("SupprimerPlat", parentMainApp.cuisinier.getUsername(), "EnvoieSuppPlat", "SERVER",Selected_Plat));
            Data_jTable.getSelectionModel().clearSelection();
            
            Categorie_jComboBox.setSelectedIndex(0);
            Nom_jTextField.setText("");
            Prix_jTextField.setText("");
            duree_jTextField.setText("");
            Image_jTextField.setText("");
            BX.setIcon(null);
            
        }catch(Exception ex){
            ex.printStackTrace();
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Erreur", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_Supprimer_jButtonActionPerformed
    
    public void SelectAction()
    {
        try {
            BX.setIcon(null);
            Selected_Row = Data_jTable.getSelectedRow();

            Plat Temp_Plat = listePlats.get(Selected_Row);
            
            Selected_categorie = Temp_Plat.getCategorie();
            Selected_nom = Temp_Plat.getNom();
            Selected_prix = Temp_Plat.getPrix();
            Selected_duree = Temp_Plat.getDuree();
            Selected_nom_image = Temp_Plat.getNom_image();
            Selected_image = Temp_Plat.getImage();
            //Selected_image=new SerialBlob(Selected_image);

            Selected_Plat = new Plat(Selected_categorie, Selected_nom, Selected_prix, Selected_duree, Selected_nom_image, Selected_image);
            

            Categorie_jComboBox.setSelectedItem(Selected_categorie);
            Nom_jTextField.setText(Selected_nom);
            Prix_jTextField.setText(""+Selected_prix);
            duree_jTextField.setText(""+Selected_duree);
            Image_jTextField.setText("./images/"+Selected_nom_image);
            Selected_FilePath = "./images/"+Selected_nom_image;
            if(ArchOS){ Selected_FilePath = Selected_FilePath.replace("\\", "/"); }
            Selected_File = new File(Selected_FilePath);
            
            int blobLength = (int) Selected_image.length();
            Selected_bytes = Selected_image.getBytes(1, blobLength);
            
            ByteArrayInputStream in = new ByteArrayInputStream(Selected_bytes);
            FileOutputStream out = new FileOutputStream(Selected_File);
            IOUtils.copy(in, out);
            IOUtils.closeQuietly(in);
            IOUtils.closeQuietly(out);
            //if(Selected_File == null) System.out.println("Selected_File null");
            
            
            

                BufferedImage image;
                image = ImageIO.read(Selected_File);
                if(image == null) System.out.println("image null");
                ImageIcon icon;
                icon = new ImageIcon(image);
                
                
                
                Image img = icon.getImage();
                BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_ARGB);
                Graphics g = bi.createGraphics();
                g.drawImage(img, 0, 0, 250, 215, null);
                ImageIcon newIcon = new ImageIcon(bi);

                BX.setIcon(newIcon);


                } catch (SQLException | IOException ex) {
                    Logger.getLogger(UpdatePlat_Form.class.getName()).log(Level.SEVERE, null, ex);
                }
    }
            
    public JFileChooser fileChooser;
   
    boolean ArchOS = System.getProperty("os.name").startsWith("Windows");
    
    
    public Plat Selected_Plat;
    public Plat New_Plat;
    
    int Selected_Row;
    String Selected_categorie;
    String Selected_nom;
    double Selected_prix;
    int Selected_duree;
    String Selected_nom_image;
    Blob Selected_image;
    String Selected_FilePath;
    File Selected_File;
    byte[] Selected_bytes;
    
    static public ArrayList<Plat> listePlats;
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel BX;
    private javax.swing.JComboBox Categorie_jComboBox;
    private javax.swing.JLabel Categorie_jLabel;
    public static javax.swing.JTable Data_jTable;
    private javax.swing.JButton Image_jButton;
    private javax.swing.JLabel Image_jLabel;
    private javax.swing.JPanel Image_jPanel;
    private javax.swing.JTextField Image_jTextField;
    private javax.swing.JButton Modifier_jButton;
    private javax.swing.JLabel Nom_jLabel;
    private javax.swing.JTextField Nom_jTextField;
    private javax.swing.JLabel Prix_jLabel;
    private javax.swing.JTextField Prix_jTextField;
    private javax.swing.JButton Supprimer_jButton;
    private javax.swing.JLabel Title_jLabel;
    private javax.swing.JLabel duree_jLabel;
    private javax.swing.JTextField duree_jTextField;
    public static javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
