package shared;

import java.io.Serializable;
import java.util.ArrayList;

public class Message implements Serializable
{
    private static final long serialVersionUID = 1L;
    
    public String type, emmeteur, corps, recepteur;
    public Plat plat=null;
    public Plat New_plat=null;
    public ArrayList<Plat> listePlats = null;
    public ArrayList<Commande> listeCommandes = null;
    public Commande mycommande = null;
    
    public Message(String type1, String emmeteur1, String corps1, String recepteur1, Plat plat){
        
        this.type = type1; 
        this.emmeteur = emmeteur1; 
        this.corps = corps1; 
        this.recepteur = recepteur1;
        this.plat = plat;
    }
    public Message(String type1, String emmeteur1, String corps1, String recepteur1, Commande commande){
        
        this.type = type1; 
        this.emmeteur = emmeteur1; 
        this.corps = corps1; 
        this.recepteur = recepteur1;
        this.mycommande = commande;
    }
    
    public Message(String type1, String emmeteur1, String corps1, String recepteur1, Plat plat, Plat New_plat){
        
        this.type = type1; 
        this.emmeteur = emmeteur1; 
        this.corps = corps1; 
        this.recepteur = recepteur1;
        this.plat = plat;
        this.New_plat = New_plat;
    }
    
    public Message(String type1, String emmeteur1, String corps1, String recepteur1, ArrayList<Plat> listePlats){
        
        this.type = type1; 
        this.emmeteur = emmeteur1; 
        this.corps = corps1; 
        this.recepteur = recepteur1;
        this.listePlats = listePlats;
    }
    
    public Message(String type1, String emmeteur1, String corps1, String recepteur1){
        
        this.type = type1; 
        this.emmeteur = emmeteur1; 
        this.corps = corps1; 
        this.recepteur = recepteur1;
    }

    public ArrayList<Commande> getListeCommandes() {
        return listeCommandes;
    }

    public void setListeCommandes(ArrayList<Commande> listeCommandes) {
        this.listeCommandes = listeCommandes;
    }

    @Override
    public String toString() {
        return "Message{" + "type=" + type + ", emmeteur=" + emmeteur + ", corps=" + corps + ", recepteur=" + recepteur + ", plat=" + plat + ", New_plat=" + New_plat + ", listePlats=" + listePlats + ", listeCommandes=" + listeCommandes + ", mycommande=" + mycommande + '}';
    }
    
    
    
}
