package com.server;

import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.io.IOException;
import java.util.Locale;
import javax.sound.sampled.AudioInputStream;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.Clip;
import javax.swing.UIManager;
import java.sql.*;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import shared.ConnexionDB;
import sun.applet.Main;


public class Server_Gui extends javax.swing.JFrame {


    public Main_Server_Thread server = null;  // Thread du Serveur qui se met en ecoute
    public Thread serverThread;
    public ConnexionDB MyConnexionDB;
    public Connection MyCon = null;
    
    public String Host=null, user=null, password=null;
    
    public Server_Gui() {
        initComponents();
        
    }
                             
   private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        Log_jTextArea = new javax.swing.JTextArea();
        Title_jLabel = new javax.swing.JLabel();
        Port_jLabel = new javax.swing.JLabel();
        Port_jTextField = new javax.swing.JTextField();
        LancerServer_jButton = new javax.swing.JButton();
        ArreterServer_jButton = new javax.swing.JButton();
        URL_Mysql_jLabel = new javax.swing.JLabel();
        Password_Mysql_Label = new javax.swing.JLabel();
        URL_Mysql_jTextField = new javax.swing.JTextField();
        userMysql_jLabel = new javax.swing.JLabel();
        userMysql_jTextField = new javax.swing.JTextField();
        Password_Mysql_jPassword = new javax.swing.JPasswordField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Cuisine ENSAS");
        setResizable(false);

        Log_jTextArea.setColumns(20);
        Log_jTextArea.setRows(5);
        jScrollPane1.setViewportView(Log_jTextArea);

        Title_jLabel.setBackground(new java.awt.Color(0, 0, 0));
        Title_jLabel.setFont(new java.awt.Font("Tahoma", 3, 24)); // NOI18N
        Title_jLabel.setForeground(new java.awt.Color(0, 0, 255));
        Title_jLabel.setText("Serveur Cuisine ENSAS");

        Port_jLabel.setText("Port Socket : ");

        Port_jTextField.setText("20000");

        LancerServer_jButton.setText("Lancer Serveur");
        LancerServer_jButton.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    LancerServer_jButtonActionPerformed(evt);
                } catch (Exception ex) {
                    Logger.getLogger(Server_Gui.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

        ArreterServer_jButton.setText("Arrêter Serveur");
        ArreterServer_jButton.setEnabled(false);
        ArreterServer_jButton.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                try {
                    ArreterServer_jButtonActionPerformed(evt);
                } catch (Exception ex) {
                    Logger.getLogger(Server_Gui.class.getName()).log(Level.SEVERE, null, ex);
                }
            }
        });

        URL_Mysql_jLabel.setText("URL MySQL");

        Password_Mysql_Label.setText("Password MySQL");

        URL_Mysql_jTextField.setText("localhost");

        userMysql_jLabel.setText("User MySQL");

        userMysql_jTextField.setText("root");
        userMysql_jTextField.addActionListener(new java.awt.event.ActionListener() {
            @Override
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                userMysql_jTextFieldActionPerformed(evt);
            }
        });
        jScrollPane1.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener() 
        {  
            @Override
            public void adjustmentValueChanged(AdjustmentEvent e) {  
            e.getAdjustable().setValue(e.getAdjustable().getMaximum());  
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 610, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(Port_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(10, 10, 10)
                                .addComponent(Port_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(20, 20, 20)
                                .addComponent(Password_Mysql_Label)
                                .addGap(8, 8, 8)
                                .addComponent(Password_Mysql_jPassword, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(URL_Mysql_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(20, 20, 20)
                                .addComponent(URL_Mysql_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 120, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(20, 20, 20)
                                .addComponent(userMysql_jLabel)
                                .addGap(32, 32, 32)
                                .addComponent(userMysql_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 110, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(40, 40, 40)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(LancerServer_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(ArreterServer_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 140, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(11, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(Title_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 390, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(76, 76, 76))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(Title_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 40, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(URL_Mysql_jLabel)
                    .addComponent(URL_Mysql_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(userMysql_jLabel)
                    .addComponent(userMysql_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(LancerServer_jButton))
                .addGap(7, 7, 7)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(Port_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Port_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Password_Mysql_Label)
                    .addComponent(Password_Mysql_jPassword, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(ArreterServer_jButton))
                .addGap(7, 7, 7)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 370, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>                        

    private void userMysql_jTextFieldActionPerformed(java.awt.event.ActionEvent evt) {                                                     
        // TODO add your handling code here:
    }                                                    

    private void LancerServer_jButtonActionPerformed(java.awt.event.ActionEvent evt) throws Exception {                                                     
        
        Host = URL_Mysql_jTextField.getText();
        user = userMysql_jTextField.getText();
        //password = Password_Mysql_jPassword.getText();
        char[] PassCharArray = Password_Mysql_jPassword.getPassword();
        password = String.valueOf(PassCharArray);
        
        
        
        MyConnexionDB = new ConnexionDB();
        MyCon = MyConnexionDB.getConnection(Host, user, password);
        
        if(MyCon!=null)
        {
            server = new Main_Server_Thread(this);
            ArreterServer_jButton.setEnabled(true);
            LancerServer_jButton.setEnabled(false);
            this.playSound("on.wav");
            Log_jTextArea.append("\nConnexion MySQL Accepté ");
        }
        
        
    }                                                    

    private void ArreterServer_jButtonActionPerformed(java.awt.event.ActionEvent evt) throws Exception {                                                      
        
            try{  
                    server.close(); 
                }
                catch(IOException ioe){  
                    this.Log_jTextArea.append("\nErreur Fermeture du thread: " + ioe); 
                }
                this.playSound("off.wav");
                server.stop();
                MyConnexionDB.disconnect();
                this.Log_jTextArea.append("\nFermeture Connexion MySQL ");
                
        LancerServer_jButton.setEnabled(true);
        ArreterServer_jButton.setEnabled(false);
    }                                                     
        public void RetryStart(int port){
            
            if(server != null){ server.stop(); }
            server = new Main_Server_Thread(this, port);
        }
        
        public static synchronized void playSound(final String url) {
        new Thread(new Runnable() {

          @Override
          public void run() {
            try {
              Clip clip = AudioSystem.getClip();
              AudioInputStream inputStream;
                inputStream = AudioSystem.getAudioInputStream(Main.class.getResourceAsStream("/sounds/" + url));
              clip.open(inputStream);
              clip.start(); 
            } catch (Exception e) {
              System.err.println(e.getMessage());
            }
          }
        }).start();
      }
        
    public static void main(String args[]) {
        
        try
        {
            Locale.setDefault(Locale.ENGLISH);
            String name = "com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel";
            UIManager.setLookAndFeel(name);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        
        
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new Server_Gui().setVisible(true);
                
            }
        });
    }
                        
    private javax.swing.JButton ArreterServer_jButton;
    private javax.swing.JButton LancerServer_jButton;
    public javax.swing.JTextArea Log_jTextArea;
    private javax.swing.JLabel Password_Mysql_Label;
    public javax.swing.JPasswordField Password_Mysql_jPassword;
    private javax.swing.JLabel Port_jLabel;
    public javax.swing.JTextField Port_jTextField;
    private javax.swing.JLabel Title_jLabel;
    private javax.swing.JLabel URL_Mysql_jLabel;
    public javax.swing.JTextField URL_Mysql_jTextField;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel userMysql_jLabel;
    public javax.swing.JTextField userMysql_jTextField;                
    public boolean ExistErreur = false;
}
