package shared;

import java.sql.*;
import java.util.ArrayList;
import javax.sql.rowset.serial.SerialBlob;
import javax.swing.JOptionPane;

public class ConnexionDB {	

		static public Connection Conn = null;
		static public PreparedStatement PrepStat= null;
		static public ResultSet ResSet= null;
                static public ResultSet ResSet1= null;
                
                static public String Host = "localhost";
                static public String url = null;
                static public String dbName = "restau";
                static public String driver = "com.mysql.jdbc.Driver";
                static public String userName = "root"; 
                static public String password = "";
                
		
		public static Connection getConnection(String New_Host, String New_user, String New_password) throws Exception 
                {
                                boolean errorExist = false;
				try{
                                    Host = New_Host;
                                    userName = New_user;
                                    password = New_password;
                                    url = "jdbc:mysql://"+Host+":3306/"+dbName;
                                    Class.forName(driver);
                                    Conn = DriverManager.getConnection(url,userName,password);
                                    Conn.setAutoCommit(false);
                                    return Conn;
                                }catch(ClassNotFoundException | SQLException ex)
                                {
                                    JOptionPane.showMessageDialog(null, "Connexion MySQL refusés", "Erreur", JOptionPane.ERROR_MESSAGE);
                                    errorExist = true;
                                    return null;
                                }
                                
                                	
		}
                public boolean CuisinierExists(String username)
                {

                    try{
                        // si il ya user dans DB return true;
                        PrepStat = Conn.prepareStatement("SELECT * FROM cuisinier WHERE name_cuisinier = ?");
                        PrepStat.setString(1, username);
                        ResSet = PrepStat.executeQuery(); 
                        String NameCuisinier="";
                        if (ResSet.next()) 
                        {
                            NameCuisinier = ResSet.getString("name_cuisinier");
                        }
                        
                        if(NameCuisinier.equals(username) ) return true;
                        return false;
                    }
                    catch(Exception ex){
                        System.out.println("exception Base de Données  : CuisinierExists()");
                        return false;
                    }
                }
                    
                public boolean checkLoginCuisinier(String username, String password)
                {

                        if(!CuisinierExists(username)){ return false; }

                        try{
                            PrepStat = Conn.prepareStatement("SELECT * FROM cuisinier WHERE name_cuisinier = ? and password_cuisinier = ?");
                            PrepStat.setString(1, username);
                            PrepStat.setString(2, password);
                            ResSet = PrepStat.executeQuery(); 
                            
                            String PassCuisinier="";
                            if (ResSet.next()) 
                            {
                                PassCuisinier = ResSet.getString("password_cuisinier");
                            }
                            
                            if(PassCuisinier.equals(password)) return true;   
                            return false;
                        }
                        catch(Exception ex){
                            System.out.println("Exception Base do DOnnées : CuisinierExists()");
                            return false;
                        }
                }
                    
                public void addCuisinier(String username, String password)
                {

                    try {

                        } 
                        catch(Exception ex)
                        {
                            System.out.println("Exception Ajout ");
                        }
                }
                public ArrayList<Plat> GetListPlatCuisinier()
                {
                    ArrayList<Plat> listePlats = new ArrayList<Plat>();
                    try{
			PrepStat = Conn.prepareStatement("Select * from plat");
			ResSet = PrepStat.executeQuery();
			while (ResSet.next())
                        {
				Plat P = new Plat();
				P.setCategorie(ResSet.getString("categorie"));
				P.setNom(ResSet.getString("nom"));
				P.setPrix(ResSet.getDouble("prix"));
                                P.setDuree(ResSet.getInt("duree"));
                                P.setNom_image(ResSet.getString("nom_image"));
                                byte[] buf = ResSet.getBytes("image");
                                java.sql.Blob blob= null;
                                blob=new SerialBlob(buf);  
                                P.setImage(blob);
				listePlats.add(P);				
			}			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return listePlats;
                }
                
                public ArrayList<Commande> LoadListeCommandeByEtat(int EtatX)
                {
                    ArrayList<Commande> listeCommande = new ArrayList<Commande>();
                    try{
                            PrepStat = Conn.prepareStatement("Select * FROM commandes WHERE etat = ?");
                            PrepStat.setInt(1, EtatX);
                            ResSet = PrepStat.executeQuery();
                            //System.out.println(getRows(ResSet));
                            while(ResSet.next())
                            {
                                    Commande P = new Commande();
                                    P.setNom_client(ResSet.getString("nom_client"));
                                    P.setQuantite(ResSet.getInt("quantite"));
                                    P.setEtat(ResSet.getInt("etat"));
                                    P.setID_Commande(ResSet.getInt("ID_commandes"));
                                    P.setCommandePlat(getPlatByName(ResSet.getString("nom_plat")));

                                    listeCommande.add(P);
                            };			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return listeCommande;
                }
                //getListeCommandeEnCours_Thread()
                public ArrayList<CommandeEnCours_Thread> getListeCommandeEnCours_Thread()
                {
                    ArrayList<CommandeEnCours_Thread> listeCommande = new ArrayList<CommandeEnCours_Thread>();
                    try{
                            PrepStat = Conn.prepareStatement("Select * FROM commandesencours");
                            ResSet = PrepStat.executeQuery();
                            
                            while(ResSet.next())
                            {
                                    CommandeEnCours_Thread P = new CommandeEnCours_Thread();
                                    P.setThreadName(ResSet.getString("ThreadName"));
                                    P.setTimePreparationinMiliSecond(ResSet.getDouble("TimePreparationinMiliSecond"));
                                    P.setProgressValue(ResSet.getInt("ProgressValue"));
                                    P.setTempsEcoule(ResSet.getInt("TempsEcoule"));
                                    P.setClackRate(ResSet.getLong("ClackRate"));
                                    P.setDb(this);
                                    
                                    listeCommande.add(P);
                            };			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return listeCommande;
                }
                public int getRows(ResultSet res)
                {
                    int totalRows = 0;
                    try    
                    {
                          res.last();
                          totalRows = res.getRow();
                          res.beforeFirst();
                    } catch(Exception ex)  
                        {
                             return 0;
                         }
                    return totalRows ;    
                }
                
                public Plat getPlatByName(String PlatName)
                {
                    Plat P = new Plat();
                    try{
                            PrepStat = Conn.prepareStatement("SELECT * FROM plat WHERE nom = ?");
                            PrepStat.setString(1, PlatName);
                            ResSet1 = PrepStat.executeQuery();
                            while (ResSet1.next())
                            {
                                    P.setCategorie(ResSet1.getString("categorie"));
                                    P.setNom(ResSet1.getString("nom"));
                                    P.setPrix(ResSet1.getDouble("prix"));
                                    P.setDuree(ResSet1.getInt("duree"));
                                    P.setNom_image(ResSet1.getString("nom_image"));
                                    byte[] buf = ResSet1.getBytes("image");
                                    java.sql.Blob blob= null;
                                    blob=new SerialBlob(buf);  
                                    P.setImage(blob);				
                            }			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return P;
                }
                // getNameClientByCommandeID
                public String getNameClientByCommandeID(int CommandeX_ID)
                {
                    String NameClient = "";
                    try{
                            PrepStat = Conn.prepareStatement("SELECT * FROM commandes WHERE ID_commandes = ?");
                            PrepStat.setInt(1, CommandeX_ID);
                            ResSet1 = PrepStat.executeQuery();
                            while (ResSet1.next())
                            {
                                    NameClient = ResSet1.getString("nom_client");				
                            }			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return NameClient;
                }
                public Commande getCommandeByCommandeID(int CommandeX_ID)
                {
                    Commande P = new Commande();
                    try{
                            PrepStat = Conn.prepareStatement("SELECT * FROM commandes WHERE ID_commandes = ?");
                            PrepStat.setInt(1, CommandeX_ID);
                            ResSet = PrepStat.executeQuery();
                            while (ResSet.next())
                            {
                                    P.setNom_client(ResSet.getString("nom_client"));
                                    P.setQuantite(ResSet.getInt("quantite"));
                                    P.setEtat(ResSet.getInt("etat"));
                                    P.setID_Commande(ResSet.getInt("ID_commandes"));
                                    P.setCommandePlat(getPlatByName(ResSet.getString("nom_plat")));			
                            }			
                        }
                        catch (SQLException e) {
                                e.printStackTrace();
                        }
                    return P;
                }
                public boolean ClientExists(String username)
                {
                    try{
                        // si il ya user dans DB return true;
                        PrepStat = Conn.prepareStatement("SELECT * FROM client WHERE name_client = ?");
                        PrepStat.setString(1, username);
                        ResSet = PrepStat.executeQuery(); 
                        String NameClient="";
                        if (ResSet.next()) 
                        {
                            NameClient = ResSet.getString("name_client");
                        }
                        
                        if(NameClient.equals(username) ) return true;
                        return false;
                    }
                    catch(Exception ex){
                        System.out.println("exception Base de Données  : ClientExists()");
                        return false;
                    }
                }
                    
                public boolean checkLoginClient(String username, String password)
                {
                    if(!ClientExists(username)){ return false; }

                        try{
                            PrepStat = Conn.prepareStatement("SELECT * FROM client WHERE name_client = ? and password_client = ?");
                            PrepStat.setString(1, username);
                            PrepStat.setString(2, password);
                            ResSet = PrepStat.executeQuery(); 
                            
                            String PassClient="";
                            if (ResSet.next()) 
                            {
                                PassClient = ResSet.getString("password_client");
                            }
                            
                            if(PassClient.equals(password)) return true;   
                            return false;
                        }
                        catch(Exception ex){
                            System.out.println("Exception Base do DOnnées : ClientExists()");
                            return false;
                        }
                }
                    
                public void addClient(String username, String password)
                {

                    try {

                        } 
                        catch(Exception ex)
                        {
                            System.out.println("Exception Ajout ");
                        }
                }
                    
                public static void disconnect() throws Exception 
                {
                    if (Conn != null) {
                        Conn.close();
                    }
                    if (PrepStat != null) {
                        PrepStat.close();
                    }
                    if (ResSet != null) {
                        ResSet.close();
                    }
                }

    public boolean AjoutPlatCuisinier(Plat P) throws SQLException {
        boolean resultB = false;
        try{
			PrepStat= Conn.prepareStatement("Insert into plat(categorie,nom,prix,duree,nom_image,image) values(?,?,?,?,?,?)");
			PrepStat.setString(1, P.getCategorie());
			PrepStat.setString(2, P.getNom());
                        PrepStat.setDouble(3, P.getPrix());
                        PrepStat.setInt(4, P.getDuree());
                        PrepStat.setString(5, P.getNom_image());
                        PrepStat.setBlob(6, P.getImage());
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        return resultB;
        }
    //AddCommandThread(newCommandThread)
     public boolean AddCommandThread(CommandeEnCours_Thread newCommandThread) throws SQLException {
        boolean resultB = false;
        try{
			PrepStat= Conn.prepareStatement("Insert into commandesencours(ThreadName, TimePreparationinMiliSecond, ProgressValue, TempsEcoule, ClackRate) values(?,?,?,?,?)");
			PrepStat.setString(1, newCommandThread.getThreadName());
                        PrepStat.setDouble(2, newCommandThread.getTimePreparationinMiliSecond());
                        PrepStat.setInt(3, newCommandThread.getProgressValue());
                        PrepStat.setInt(4, newCommandThread.getTempsEcoule());
                        PrepStat.setLong(5, newCommandThread.getClackRate());
			
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        return resultB;
        }
     public boolean RemoveCommandThread(CommandeEnCours_Thread newCommandThread) throws SQLException {
        boolean resultB = false;
        try{
			PrepStat= Conn.prepareStatement("DELETE FROM commandesencours WHERE ThreadName = ? AND TimePreparationinMiliSecond = ? AND TempsEcoule=? ");
                        
                        PrepStat.setString(1, newCommandThread.getThreadName());
                        PrepStat.setDouble(2, newCommandThread.getTimePreparationinMiliSecond());
                        PrepStat.setInt(3, newCommandThread.getTempsEcoule());
			
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        return resultB;
        }
     //db.UpdateCommandThread(ThreadName, ProgressValue, TempsEcoule)
     public boolean UpdateCommandThread(String ThreadName, int ProgressValue, int TempsEcoule) throws SQLException
    {
        boolean resultB = false;
                try{                                                   
			PrepStat= Conn.prepareStatement("UPDATE commandesencours SET ProgressValue=?, TempsEcoule=? WHERE ThreadName=?");
			PrepStat.setInt(1, ProgressValue);
                        PrepStat.setInt(2, TempsEcoule);
                        PrepStat.setString(3, ThreadName);
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
                    } catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                return resultB;   
     }
    public boolean CommanderPlatClient(Commande mycommande) throws SQLException {
        boolean resultB = false;
        try{
			PrepStat= Conn.prepareStatement("Insert into commandes(nom_client,nom_plat,quantite,etat) values(?,?,?,?)");
			PrepStat.setString(1, mycommande.getNom_client());
			PrepStat.setString(2, mycommande.getCommandePlat().getNom());
                        PrepStat.setDouble(3, mycommande.getQuantite());
                        PrepStat.setInt(4, mycommande.getEtat());
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        return resultB;
        }
    
        public ArrayList<Plat> SupprPlatCuisinier(Plat P) throws SQLException {
        
        ArrayList<Plat> listePlats = null;
        try{
			PrepStat= Conn.prepareStatement("DELETE FROM plat WHERE categorie = ? AND nom = ? AND nom_image=? ");
			PrepStat.setString(1, P.getCategorie());
			PrepStat.setString(2, P.getNom());
                        PrepStat.setString(3, P.getNom_image());
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            listePlats = GetListPlatCuisinier();
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        finally
                        {
                            return listePlats;
                        }
        }
    

    public ArrayList<Plat> ModifPlatCuisinier(Message msg) throws SQLException
    {
        ArrayList<Plat> listePlats = null;
        try{
			PrepStat= Conn.prepareStatement("update plat set categorie=?,nom=?,prix=?,duree=?,nom_image=?,image=?" + "where categorie=? and nom=?");
			PrepStat.setString(1, msg.New_plat.getCategorie());
			PrepStat.setString(2, msg.New_plat.getNom());
                        PrepStat.setDouble(3, msg.New_plat.getPrix());
                        PrepStat.setInt(4, msg.New_plat.getDuree());
                        PrepStat.setString(5, msg.New_plat.getNom_image());
                        PrepStat.setBlob(6, msg.New_plat.getImage());
                        PrepStat.setString(7, msg.plat.getCategorie());
                        PrepStat.setString(8, msg.plat.getNom());
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            listePlats = GetListPlatCuisinier();
                            Conn.commit();
                        }
			} catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                        finally
                        {
                            return listePlats;
                        }
        }
    //CommencerPreparerCommandeMoveTo2(msg.mycommande)
    public boolean CommencerPreparerCommandeMoveTo2(Commande myCommande) throws SQLException
    {
        boolean resultB = false;
                try{                                                   
			PrepStat= Conn.prepareStatement("UPDATE commandes SET etat=? WHERE ID_commandes=?");
			PrepStat.setInt(1, 2);
                        PrepStat.setInt(2, myCommande.getID_Commande());
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
                    } catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                return resultB;   
     }
    
    public boolean EndPreparationCommandeMoveTo3(int ID) throws SQLException
    {
        boolean resultB = false;
                try{                                                   
			PrepStat= Conn.prepareStatement("UPDATE commandes SET etat=? WHERE ID_commandes=?");
			PrepStat.setInt(1, 3);
                        PrepStat.setInt(2, ID);
                        
                        if (PrepStat.executeUpdate() == 1) 
                        {
                            resultB = true;
                            Conn.commit();
                        }
                    } catch (Exception e) {
                            Conn.rollback();
                            throw e;
                        }
                return resultB;   
     }
}
