package Form;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;
import java.sql.Blob;
import javax.imageio.ImageIO;
import javax.sql.rowset.serial.SerialBlob;
import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;
import shared.Message;
import shared.Plat;


public class AjoutPlat_Form extends javax.swing.JInternalFrame {

    public MainApp parentMainApp;
    
    public AjoutPlat_Form(MainApp parent) {
        parentMainApp = parent;
        initComponents();
        //setBounds(100, 100, 666, 322);
    }


    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        Image_jTextField = new javax.swing.JTextField();
        duree_jTextField = new javax.swing.JTextField();
        Image_jLabel = new javax.swing.JLabel();
        Prix_jLabel = new javax.swing.JLabel();
        duree_jLabel = new javax.swing.JLabel();
        Nom_jLabel = new javax.swing.JLabel();
        Prix_jTextField = new javax.swing.JTextField();
        Categorie_jLabel = new javax.swing.JLabel();
        Nom_jTextField = new javax.swing.JTextField();
        Image_jButton = new javax.swing.JButton();
        Ajouter_jButton = new javax.swing.JButton();
        Reset_jButton = new javax.swing.JButton();
        Categorie_jComboBox = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        Image_jPanel = new javax.swing.JPanel();
        BX = new javax.swing.JLabel();

        setBackground(new java.awt.Color(191, 205, 219));
        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Ajouter Plat");
        setFrameIcon(new javax.swing.ImageIcon(getClass().getResource("/images/add.png"))); // NOI18N

        Image_jTextField.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N

        duree_jTextField.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N

        Image_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jLabel.setText("Image du Plat :");

        Prix_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Prix_jLabel.setText("Prix du Plat :");

        duree_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        duree_jLabel.setText("Durée Préparation :");

        Nom_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Nom_jLabel.setText("Nom Plat :");

        Prix_jTextField.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N

        Categorie_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Categorie_jLabel.setText("Categorie Plat :");

        Nom_jTextField.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N

        Image_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jButton.setText("Parcourir");
        Image_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Image_jButtonActionPerformed(evt);
            }
        });

        Ajouter_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Ajouter_jButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/filesave.png"))); // NOI18N
        Ajouter_jButton.setText("Ajouter Plat");
        Ajouter_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Ajouter_jButtonActionPerformed(evt);
            }
        });

        Reset_jButton.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Reset_jButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/cut.png"))); // NOI18N
        Reset_jButton.setText("Reset");
        Reset_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Reset_jButtonActionPerformed(evt);
            }
        });

        Categorie_jComboBox.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Categorie_jComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" }));

        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 16)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(0, 0, 255));
        jLabel1.setText("Ajouter un Plat");

        Image_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Image du Plat"));
        Image_jPanel.add(BX);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(Ajouter_jButton)
                                .addGap(18, 18, 18)
                                .addComponent(Reset_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 145, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(duree_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Prix_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Nom_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Categorie_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(Nom_jTextField)
                                    .addComponent(Prix_jTextField)
                                    .addComponent(duree_jTextField)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(Image_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 148, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(Image_jButton))
                                    .addComponent(Categorie_jComboBox, javax.swing.GroupLayout.Alignment.TRAILING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(212, 212, 212)
                        .addComponent(jLabel1)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Image_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 227, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(Image_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(8, 8, 8)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Categorie_jLabel)
                            .addComponent(Categorie_jComboBox, javax.swing.GroupLayout.DEFAULT_SIZE, 26, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Nom_jLabel)
                            .addComponent(Nom_jTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 27, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Prix_jLabel)
                            .addComponent(Prix_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 24, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(duree_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 19, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(1, 1, 1)
                                .addComponent(duree_jTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 26, Short.MAX_VALUE)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Image_jLabel)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(1, 1, 1)
                                .addComponent(Image_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(Image_jButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Reset_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Ajouter_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 47, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(50, 50, 50))))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void Image_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Image_jButtonActionPerformed

        BufferedImage image;
        String fileName = "achards-de-legumes_320x320.jpg";
        String dir = "./images/";
        if(ArchOS){ dir = dir.replace("\\", "/"); }

            try{
                FileNameExtensionFilter filter = new FileNameExtensionFilter("Image file only", "jpg", "jpeg","bmp","png");
                fileChooser = new JFileChooser();
                fileChooser.setCurrentDirectory(new File(dir));
                fileChooser.setSelectedFile(new File(fileName));
                fileChooser.setFileFilter(filter);
                fileChooser.setAcceptAllFileFilterUsed(false);

                int returnValue = fileChooser.showDialog(this, "Choisir Image du Plat");

                if (returnValue == JFileChooser.APPROVE_OPTION){

                    file=fileChooser.getSelectedFile();
                    nomImageX = file.getName();

                    image=ImageIO.read(file);
                    ImageIcon icon;
                    icon = new ImageIcon(image);

                    Image img = icon.getImage();
                    BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_ARGB);
                    Graphics g = bi.createGraphics();
                    g.drawImage(img, 0, 0, 230, 250, null);
                    ImageIcon newIcon = new ImageIcon(bi);

                    BX.setIcon(newIcon);

                    if(file != null){

                        filePath = file.getPath();
                        if(ArchOS){ filePath = filePath.replace("\\", "/"); }
                            Image_jTextField.setText(filePath);
                        }

                    }

                }catch(Exception e){System.out.println(e);}
    }//GEN-LAST:event_Image_jButtonActionPerformed

    private void Ajouter_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Ajouter_jButtonActionPerformed

        
        try {

            String Categorie_String = (String)Categorie_jComboBox.getSelectedItem();
            String Nom_String = Nom_jTextField.getText();
            double Prix_Double = Double.parseDouble(Prix_jTextField.getText());
            int duree_int = Integer.parseInt(duree_jTextField.getText());
            byte[] myByte = new byte[(int) file.length()];

            try {
                //convert file into array of bytes
                FileInputStream fileInputStream=null;
                fileInputStream = new FileInputStream(file);
                fileInputStream.read(myByte);
                fileInputStream.close();
            }catch(Exception e){
                System.out.println("blob");
            }

            Blob blob= null;
            blob=new SerialBlob(myByte);

            Plat P = new Plat(Categorie_String, Nom_String, Prix_Double, duree_int, nomImageX, blob);
            parentMainApp.cuisinier.send(new Message("AjoutPlat", parentMainApp.cuisinier.getUsername(), "EnvoiePlat", "SERVER",P));
            //System.out.println(P.toString());
                Categorie_jComboBox.setSelectedIndex(0);
                Nom_jTextField.setText("");
                Prix_jTextField.setText("");
                duree_jTextField.setText("");
                Image_jTextField.setText("");
                BX.setIcon(null);

                filePath="";
                file = null;
                nomImageX="";
            
        }catch(Exception ex){
            ex.printStackTrace();
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Erreur", JOptionPane.ERROR_MESSAGE);
        }

    }//GEN-LAST:event_Ajouter_jButtonActionPerformed

    private void Reset_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Reset_jButtonActionPerformed
        Categorie_jComboBox.setSelectedIndex(0);
                Nom_jTextField.setText("");
                Prix_jTextField.setText("");
                duree_jTextField.setText("");
                Image_jTextField.setText("");
                BX.setIcon(null);
    }//GEN-LAST:event_Reset_jButtonActionPerformed
    
    public JFileChooser fileChooser;
    public String filePath;
    public File file;
    public String nomImageX;
    
    private OutputStream os;
    private ObjectOutputStream oos;
    private InputStream is;
    private ObjectInputStream ois;
    boolean ArchOS = System.getProperty("os.name").startsWith("Windows");
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton Ajouter_jButton;
    private javax.swing.JLabel BX;
    private javax.swing.JComboBox Categorie_jComboBox;
    private javax.swing.JLabel Categorie_jLabel;
    private javax.swing.JButton Image_jButton;
    private javax.swing.JLabel Image_jLabel;
    private javax.swing.JPanel Image_jPanel;
    private javax.swing.JTextField Image_jTextField;
    private javax.swing.JLabel Nom_jLabel;
    private javax.swing.JTextField Nom_jTextField;
    private javax.swing.JLabel Prix_jLabel;
    private javax.swing.JTextField Prix_jTextField;
    private javax.swing.JButton Reset_jButton;
    private javax.swing.JLabel duree_jLabel;
    private javax.swing.JTextField duree_jTextField;
    private javax.swing.JLabel jLabel1;
    // End of variables declaration//GEN-END:variables
}
