package Form;

import com.javaswingcomponents.accordion.JSCAccordion;
import com.javaswingcomponents.accordion.TabOrientation;
import com.javaswingcomponents.accordion.plaf.steel.SteelAccordionUI;
import com.javaswingcomponents.framework.painters.configurationbound.GradientColorPainter;
import com.javaswingcomponents.framework.painters.configurationbound.GradientDirection;

import java.awt.Color;
import java.awt.Component;
import javax.swing.BorderFactory;

import Model.AccordionTabRendererMenu;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Blob;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.event.InternalFrameEvent;
import org.apache.commons.io.IOUtils;
import shared.Commande;
import shared.Message;
import shared.Plat;

public class CommandePlat_Form extends javax.swing.JInternalFrame {
    
    public MainApp parentMainApp;
    
                JPanel Entree_Panel = new JPanel(new GridLayout(0, 1));
                JPanel Platprincipal_Panel = new JPanel(new GridLayout(0, 1));
                JPanel Soupe_Panel = new JPanel(new GridLayout(0, 1));
                JPanel Dessert_Panel = new JPanel(new GridLayout(0, 1));
                JPanel Boisson_Panel = new JPanel(new GridLayout(0, 1));
                JPanel Confiserie_Panel = new JPanel(new GridLayout(0, 1));

   public CommandePlat_Form(MainApp parent) 
   {
       parentMainApp = parent; 
       parentMainApp.client.send(new Message("ListPlat", parentMainApp.client.getUsername(), "SendMeTheListOfPlat", "SERVER"));
       initComponents();
       while(listePlats.isEmpty()){}
       createSpecificListe();
       ListePlats_jPanel.add(createCustomAccordion());
   }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ListePlats_jPanel = new javax.swing.JPanel();
        DetailsPlat_jPanel = new javax.swing.JPanel();
        Nom_jTextField = new javax.swing.JTextField();
        Image_jLabel = new javax.swing.JLabel();
        Image_jTextField = new javax.swing.JTextField();
        Nom_jLabel = new javax.swing.JLabel();
        Categorie_jComboBox = new javax.swing.JComboBox();
        duree_jTextField = new javax.swing.JTextField();
        Categorie_jLabel = new javax.swing.JLabel();
        Prix_jLabel = new javax.swing.JLabel();
        Prix_jTextField = new javax.swing.JTextField();
        duree_jLabel = new javax.swing.JLabel();
        Commander_jButton = new javax.swing.JButton();
        Image_jPanel = new javax.swing.JPanel();
        BX = new javax.swing.JLabel();
        Quantite_jLabel = new javax.swing.JLabel();
        Quantite_jTextField = new javax.swing.JTextField();

        setBackground(java.awt.SystemColor.inactiveCaption);
        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Commander Plats");

        ListePlats_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Plats Disponible"));
        ListePlats_jPanel.setLayout(new java.awt.GridLayout(1, 0));

        DetailsPlat_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Détails du Plat"));

        Image_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jLabel.setText("Image du Plat :");

        Nom_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Nom_jLabel.setText("Nom Plat :");

        Categorie_jComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" }));

        Categorie_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Categorie_jLabel.setText("Categorie Plat :");

        Prix_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Prix_jLabel.setText("Prix du Plat :");

        duree_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        duree_jLabel.setText("Durée Préparation :");

        Commander_jButton.setText("Commander");
        Commander_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Commander_jButtonActionPerformed(evt);
            }
        });

        Image_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Image du Plat"));

        javax.swing.GroupLayout Image_jPanelLayout = new javax.swing.GroupLayout(Image_jPanel);
        Image_jPanel.setLayout(Image_jPanelLayout);
        Image_jPanelLayout.setHorizontalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Image_jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BX, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
                .addContainerGap())
        );
        Image_jPanelLayout.setVerticalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Image_jPanelLayout.createSequentialGroup()
                .addComponent(BX, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE)
                .addContainerGap())
        );

        Quantite_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Quantite_jLabel.setText("Quantité demandé");

        Quantite_jTextField.setText("1");

        javax.swing.GroupLayout DetailsPlat_jPanelLayout = new javax.swing.GroupLayout(DetailsPlat_jPanel);
        DetailsPlat_jPanel.setLayout(DetailsPlat_jPanelLayout);
        DetailsPlat_jPanelLayout.setHorizontalGroup(
            DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, DetailsPlat_jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(Nom_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(Categorie_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Prix_jLabel)
                    .addComponent(duree_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(Quantite_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(Prix_jTextField)
                    .addComponent(duree_jTextField)
                    .addComponent(Image_jTextField)
                    .addComponent(Categorie_jComboBox, 0, 195, Short.MAX_VALUE)
                    .addComponent(Nom_jTextField)
                    .addComponent(Quantite_jTextField)
                    .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                        .addComponent(Commander_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Image_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        DetailsPlat_jPanelLayout.setVerticalGroup(
            DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Categorie_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Categorie_jLabel))
                        .addGap(7, 7, 7)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Nom_jLabel)
                            .addComponent(Nom_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Prix_jLabel)
                            .addComponent(Prix_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(duree_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                                .addGap(3, 3, 3)
                                .addComponent(duree_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addGap(18, 18, 18)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Image_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Quantite_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Quantite_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(Commander_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(Image_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(129, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ListePlats_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 248, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(DetailsPlat_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(DetailsPlat_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(ListePlats_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void Commander_jButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Commander_jButtonActionPerformed
        int Quantite = Integer.parseInt(Quantite_jTextField.getText());
        Commande mycommande = new Commande(parentMainApp.client.getUsername(), Wanted_Plat, Quantite, 1);
        parentMainApp.client.send(new Message("CommanderPlat", parentMainApp.client.getUsername(), "CommanderPlat", "SERVER", mycommande));
    }//GEN-LAST:event_Commander_jButtonActionPerformed
    private void createSpecificListe()
    {
        if(!listePlats.isEmpty())
        {
            //System.out.println("taille liste plats : "+listePlats.size());
            for(Plat Temp : listePlats)
            {
                switch(Temp.getCategorie())
                {
                    case "Entrée":
                                    listeEntree.add(Temp);
                                    break;
                    case "Soupe":
                                    listeSoupe.add(Temp);
                                    break;
                    case "Plat principal":
                                    listePlatPrincipal.add(Temp);
                                    break;
                    case "Dessert":
                                    listeDessert.add(Temp);
                                    break;
                    case "Boisson":
                                    listeBoisson.add(Temp);
                                    break;
                    case "Confiserie":
                                    listeConfiserie.add(Temp);
                                    break;
                    default: 
                                    System.out.println("categorie inconnue");
                                    break;
                }
            }
        }
    }
    private Component createCustomAccordion() {
        
                
                
                ArrayList<JRadioButton> listeEntreeRadioS = new ArrayList<JRadioButton>();
                JRadioButton EntreeRadioS = new JRadioButton();
                ButtonGroup Entree_group = new ButtonGroup();
                
                ArrayList<JRadioButton> listePlatprincipalRadioS = new ArrayList<JRadioButton>();
                JRadioButton PlatprincipalRadioS = new JRadioButton();
                ButtonGroup Platprincipal_group = new ButtonGroup();
                
                ArrayList<JRadioButton> listeSoupeRadioS = new ArrayList<JRadioButton>();
                JRadioButton SoupeRadioS = new JRadioButton();
                ButtonGroup Soupe_group = new ButtonGroup();
                
                ArrayList<JRadioButton> listeDessertRadioS = new ArrayList<JRadioButton>();
                JRadioButton DessertRadioS = new JRadioButton();
                ButtonGroup Dessert_group = new ButtonGroup();
                
                ArrayList<JRadioButton> listeBoissonRadioS = new ArrayList<JRadioButton>();
                JRadioButton BoissonRadioS = new JRadioButton();
                ButtonGroup Boisson_group = new ButtonGroup();
                
                ArrayList<JRadioButton> listeConfiserieRadioS = new ArrayList<JRadioButton>();
                JRadioButton ConfiserieRadioS = new JRadioButton();
                ButtonGroup Confiserie_group = new ButtonGroup();
                
                for(int i=0;i<listeEntree.size();i++)   
                {
                    Plat Temp = listeEntree.get(i);
                    EntreeRadioS = new JRadioButton(Temp.getNom());
                    listeEntreeRadioS.add(EntreeRadioS);
                    listeEntreeRadioS.get(i).setActionCommand(String.valueOf(i));
                    Entree_group.add(listeEntreeRadioS.get(i));
                    Entree_Panel.add(listeEntreeRadioS.get(i));
                }
                for(int i=0;i<listePlatPrincipal.size();i++)
                {
                    Plat Temp = listePlatPrincipal.get(i);
                    PlatprincipalRadioS = new JRadioButton(Temp.getNom());
                    listePlatprincipalRadioS.add(PlatprincipalRadioS);
                    listePlatprincipalRadioS.get(i).setActionCommand(String.valueOf(i));
                    Platprincipal_group.add(listePlatprincipalRadioS.get(i));
                    Platprincipal_Panel.add(listePlatprincipalRadioS.get(i));
                }
                for(int i=0;i<listeSoupe.size();i++)
                {
                    Plat Temp = listeSoupe.get(i);
                    SoupeRadioS = new JRadioButton(Temp.getNom());
                    listeSoupeRadioS.add(SoupeRadioS);
                    listeSoupeRadioS.get(i).setActionCommand(String.valueOf(i));
                    Soupe_group.add(listeSoupeRadioS.get(i));
                    Soupe_Panel.add(listeSoupeRadioS.get(i));
                }
                for(int i=0;i<listeDessert.size();i++)
                {
                    Plat Temp = listeDessert.get(i);
                    DessertRadioS = new JRadioButton(Temp.getNom());
                    listeDessertRadioS.add(DessertRadioS);
                    listeDessertRadioS.get(i).setActionCommand(String.valueOf(i));
                    Dessert_group.add(listeDessertRadioS.get(i));
                    Dessert_Panel.add(listeDessertRadioS.get(i));
                }
                for(int i=0;i<listeBoisson.size();i++)
                {
                    Plat Temp = listeBoisson.get(i);
                    BoissonRadioS = new JRadioButton(Temp.getNom());
                    listeBoissonRadioS.add(BoissonRadioS);
                    listeBoissonRadioS.get(i).setActionCommand(String.valueOf(i));
                    Boisson_group.add(listeBoissonRadioS.get(i));
                    Boisson_Panel.add(listeBoissonRadioS.get(i));
                }
                for(int i=0;i<listeConfiserie.size();i++)
                {
                    Plat Temp = listeConfiserie.get(i);
                    ConfiserieRadioS = new JRadioButton(Temp.getNom());
                    listeConfiserieRadioS.add(ConfiserieRadioS);
                    listeConfiserieRadioS.get(i).setActionCommand(String.valueOf(i));
                    Confiserie_group.add(listeConfiserieRadioS.get(i));
                    Confiserie_Panel.add(listeConfiserieRadioS.get(i));
                }
                /* "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" */
                
                for(int i=0;i<listeEntreeRadioS.size();i++)
                {
                    listeEntreeRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(),"Entrée");
                      }
                    });
                }
                
                for(int i=0;i<listePlatprincipalRadioS.size();i++)
                {
                    listePlatprincipalRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(),"Plat principal");
                      }
                    });
                }
                
                for(int i=0;i<listeSoupeRadioS.size();i++)
                {
                    listeSoupeRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(), "Soupe");
                      }
                    });
                }
                
                for(int i=0;i<listeDessertRadioS.size();i++)
                {
                    listeDessertRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(), "Dessert");
                      }
                    });
                }
                for(int i=0;i<listeBoissonRadioS.size();i++)
                {
                    listeBoissonRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(), "Boisson");
                      }
                    });
                }
                for(int i=0;i<listeConfiserieRadioS.size();i++)
                {
                    listeConfiserieRadioS.get(i).addActionListener(new ActionListener()
                    {
                      @Override
                      public void actionPerformed(ActionEvent e)
                      {
                        SelectAction(e.getActionCommand(), "Confiserie");
                      }
                    });
                }
		JSCAccordion accordion = new JSCAccordion();
		/*    "Entree", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie"   */
		accordion.addTab("Entree", new JScrollPane(Entree_Panel));
		accordion.addTab("Plat principal", new JScrollPane(Platprincipal_Panel));
                accordion.addTab("Soupe", new JScrollPane(Soupe_Panel));
                accordion.addTab("Dessert", new JScrollPane(Dessert_Panel));
                accordion.addTab("Boisson", new JScrollPane(Boisson_Panel));
                accordion.addTab("Confiserie", new JScrollPane(Confiserie_Panel));

		//lays out the accordion's tabs to move vertically.
		accordion.setTabOrientation(TabOrientation.VERTICAL);
		//adjusts the height of the tabs to be 31 pixels
		accordion.setTabHeight(31);
		//stops the accordion rendering its shadows
		accordion.setDrawShadow(false);
		//the asp.net accordion has a border comprising a black then white border
		accordion.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(Color.BLACK),BorderFactory.createLineBorder(Color.WHITE)));
		
		//we know the default UI for the accordion is the SteelAccordionUI
		SteelAccordionUI steelAccordionUI = (SteelAccordionUI) accordion.getUI();
		
		//we set all the paddings to zero
		steelAccordionUI.setHorizontalBackgroundPadding(0);
		steelAccordionUI.setVerticalBackgroundPadding(0);
		steelAccordionUI.setHorizontalTabPadding(0);
		steelAccordionUI.setVerticalTabPadding(0);
		steelAccordionUI.setTabPadding(0);
		
		//we will replace the current background painter with a new GradientColorPainter. 
		GradientColorPainter backgroundPainter = new GradientColorPainter();
		//paint gradient horizontally
		backgroundPainter.setGradientDirection(GradientDirection.HORIZONTAL);
		//start with white
		backgroundPainter.setStartColor(new Color(255,255,255));
		//end with grey
		backgroundPainter.setEndColor(new Color(214,213,228));
		//apply the painter to the accordion
		accordion.setBackgroundPainter(backgroundPainter);
	
		//apply the new TabRenderer to the accordion.
		accordion.setVerticalAccordionTabRenderer(new AccordionTabRendererMenu());
		return accordion;
	}
    
    public void SelectAction(String Command, String Type)
    {/* "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" */
        int Row = Integer.parseInt(Command);
        
        try {
            BX.setIcon(null);
            
            switch(Type)
            {
                case "Entrée":
                                Wanted_Plat = listeEntree.get(Row);
                                break;
                case "Soupe":
                                Wanted_Plat = listeSoupe.get(Row);
                                break;
                case "Plat principal":
                                Wanted_Plat = listePlatPrincipal.get(Row);
                                break;
                case "Dessert":
                                Wanted_Plat = listeDessert.get(Row);
                                break;
                case "Boisson":
                                Wanted_Plat = listeBoisson.get(Row);
                                break;
                case "Confiserie":
                                Wanted_Plat = listeConfiserie.get(Row);
                                break;
                default: 
                                Wanted_Plat = null;
                                System.out.println("categorie inconnue");
                                break;
            }
            
            
            
            Selected_categorie = Wanted_Plat.getCategorie();
            Selected_nom = Wanted_Plat.getNom();
            Selected_prix = Wanted_Plat.getPrix();
            Selected_duree = Wanted_Plat.getDuree();
            Selected_nom_image = Wanted_Plat.getNom_image();
            Selected_image = Wanted_Plat.getImage();

         
            Categorie_jComboBox.setSelectedItem(Selected_categorie);
            Nom_jTextField.setText(Selected_nom);
            Prix_jTextField.setText(""+Selected_prix);
            duree_jTextField.setText(""+Selected_duree);
            Image_jTextField.setText("./images/"+Selected_nom_image);
            Selected_FilePath = "./images/"+Selected_nom_image;
            
            if(ArchOS){ Selected_FilePath = Selected_FilePath.replace("\\", "/"); }
            Selected_File = new File(Selected_FilePath);
            
            int blobLength = (int) Selected_image.length();
            Selected_bytes = Selected_image.getBytes(1, blobLength);
            
            ByteArrayInputStream in = new ByteArrayInputStream(Selected_bytes);
            FileOutputStream out = new FileOutputStream(Selected_File);
            IOUtils.copy(in, out);
            IOUtils.closeQuietly(in);
            IOUtils.closeQuietly(out);

                BufferedImage image;
                image = ImageIO.read(Selected_File);
                if(image == null) System.out.println("image null");
                ImageIcon icon;
                icon = new ImageIcon(image);
                

                Image img = icon.getImage();
                BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_ARGB);
                Graphics g = bi.createGraphics();
                g.drawImage(img, 0, 0, 250, 215, null);
                ImageIcon newIcon = new ImageIcon(bi);

                BX.setIcon(newIcon);
                
                } catch (SQLException | IOException ex) {
                    Logger.getLogger(UpdatePlat_Form.class.getName()).log(Level.SEVERE, null, ex);
                }
    }
    
    static public ArrayList<Plat> listePlats = new ArrayList<Plat>();
    /*    "Entree", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie"   */
     public ArrayList<Plat> listeEntree = new ArrayList<Plat>();
     public ArrayList<Plat> listeSoupe = new ArrayList<Plat>();
     public ArrayList<Plat> listePlatPrincipal = new ArrayList<Plat>();
     public ArrayList<Plat> listeDessert = new ArrayList<Plat>();
     public ArrayList<Plat> listeBoisson = new ArrayList<Plat>();
     public ArrayList<Plat> listeConfiserie = new ArrayList<Plat>();
    
    String Selected_categorie;
    String Selected_nom;
    double Selected_prix;
    int Selected_duree;
    String Selected_nom_image;
    Blob Selected_image;
    String Selected_FilePath;
    File Selected_File;
    byte[] Selected_bytes;
    public Plat Wanted_Plat;
    
    boolean ArchOS = System.getProperty("os.name").startsWith("Windows");
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel BX;
    private javax.swing.JComboBox Categorie_jComboBox;
    private javax.swing.JLabel Categorie_jLabel;
    private javax.swing.JButton Commander_jButton;
    private javax.swing.JPanel DetailsPlat_jPanel;
    private javax.swing.JLabel Image_jLabel;
    private javax.swing.JPanel Image_jPanel;
    private javax.swing.JTextField Image_jTextField;
    private javax.swing.JPanel ListePlats_jPanel;
    private javax.swing.JLabel Nom_jLabel;
    private javax.swing.JTextField Nom_jTextField;
    private javax.swing.JLabel Prix_jLabel;
    private javax.swing.JTextField Prix_jTextField;
    private javax.swing.JLabel Quantite_jLabel;
    private javax.swing.JTextField Quantite_jTextField;
    private javax.swing.JLabel duree_jLabel;
    private javax.swing.JTextField duree_jTextField;
    // End of variables declaration//GEN-END:variables
}
