package Form;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Blob;
import java.sql.SQLException;
import java.util.ArrayList;
import javax.imageio.ImageIO;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.table.DefaultTableModel;
import org.apache.commons.io.IOUtils;
import shared.Commande;
import shared.Message;
import util.RefreshProgressBar_Thread;


public class CommandesDemandes_Form extends javax.swing.JInternalFrame  {

    public MainApp parentMainApp;
    static public DefaultTableModel   table = null;
    public static ArrayList<Commande> listeCommandeDemandes1 = new ArrayList<Commande>();
    public static javax.swing.JTable CommandeDemandees_jTable = new javax.swing.JTable();
    
    public CommandesDemandes_Form(MainApp parent) {
        
        
        initComponents();
        parentMainApp = parent;
        parentMainApp.cuisinier.send(new Message("ListCommandesDemandes", parentMainApp.cuisinier.getUsername(), "SendMeTheListOfCommandesDemandes", "SERVER"));
        
        
    }


    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        DetailsPlat_jPanel = new javax.swing.JPanel();
        Nom_jTextField = new javax.swing.JTextField();
        Image_jLabel = new javax.swing.JLabel();
        Image_jTextField = new javax.swing.JTextField();
        Nom_jLabel = new javax.swing.JLabel();
        Categorie_jComboBox = new javax.swing.JComboBox();
        duree_jTextField = new javax.swing.JTextField();
        Categorie_jLabel = new javax.swing.JLabel();
        Prix_jLabel = new javax.swing.JLabel();
        Prix_jTextField = new javax.swing.JTextField();
        duree_jLabel = new javax.swing.JLabel();
        Preparer_jButton = new javax.swing.JButton();
        Image_jPanel = new javax.swing.JPanel();
        BX = new javax.swing.JLabel();
        Quantite_jLabel = new javax.swing.JLabel();
        Quantite_jTextField = new javax.swing.JTextField();
        Title_jLabel = new javax.swing.JLabel();

        setBackground(java.awt.SystemColor.inactiveCaption);
        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Les Commandes demandés par les Clients");

        CommandeDemandees_jTable.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                CommandeDemandees_jTableMouseClicked(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                CommandeDemandees_jTableMousePressed(evt);
            }
        });
        CommandeDemandees_jTable.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                CommandeDemandees_jTableKeyPressed(evt);
            }
        });
        jScrollPane1.setViewportView(CommandeDemandees_jTable);

        DetailsPlat_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Détails du Plat"));

        Image_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Image_jLabel.setText("Image du Plat :");

        Nom_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Nom_jLabel.setText("Nom Plat :");

        Categorie_jComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Entrée", "Soupe", "Plat principal", "Dessert", "Boisson", "Confiserie" }));

        Categorie_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Categorie_jLabel.setText("Categorie Plat :");

        Prix_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Prix_jLabel.setText("Prix du Plat :");

        duree_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        duree_jLabel.setText("Durée Préparation :");

        Preparer_jButton.setText("Commencer Préparation");
        Preparer_jButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                Preparer_jButtonActionPerformed(evt);
            }
        });

        Image_jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Image du Plat"));

        javax.swing.GroupLayout Image_jPanelLayout = new javax.swing.GroupLayout(Image_jPanel);
        Image_jPanel.setLayout(Image_jPanelLayout);
        Image_jPanelLayout.setHorizontalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(Image_jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(BX, javax.swing.GroupLayout.PREFERRED_SIZE, 178, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(22, Short.MAX_VALUE))
        );
        Image_jPanelLayout.setVerticalGroup(
            Image_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(BX, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 264, Short.MAX_VALUE)
        );

        Quantite_jLabel.setFont(new java.awt.Font("Tahoma", 1, 14)); // NOI18N
        Quantite_jLabel.setText("Quantité demandé");

        Quantite_jTextField.setText("1");

        javax.swing.GroupLayout DetailsPlat_jPanelLayout = new javax.swing.GroupLayout(DetailsPlat_jPanel);
        DetailsPlat_jPanel.setLayout(DetailsPlat_jPanelLayout);
        DetailsPlat_jPanelLayout.setHorizontalGroup(
            DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, DetailsPlat_jPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(Nom_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Categorie_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 132, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Prix_jLabel)
                            .addComponent(duree_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Quantite_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(18, 18, 18)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(Prix_jTextField)
                            .addComponent(duree_jTextField)
                            .addComponent(Image_jTextField)
                            .addComponent(Categorie_jComboBox, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(Nom_jTextField)
                            .addComponent(Quantite_jTextField)))
                    .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                        .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(3, 3, 3)
                        .addComponent(Preparer_jButton)
                        .addGap(0, 105, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(Image_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        DetailsPlat_jPanelLayout.setVerticalGroup(
            DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                .addContainerGap(19, Short.MAX_VALUE)
                .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Categorie_jComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Categorie_jLabel))
                        .addGap(7, 7, 7)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Nom_jLabel)
                            .addComponent(Nom_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Prix_jLabel)
                            .addComponent(Prix_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(duree_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addGroup(DetailsPlat_jPanelLayout.createSequentialGroup()
                                .addGap(3, 3, 3)
                                .addComponent(duree_jLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                        .addGap(18, 18, 18)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Image_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Image_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(DetailsPlat_jPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(Quantite_jLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(Quantite_jTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18)
                        .addComponent(Preparer_jButton, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(Image_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        Title_jLabel.setFont(new java.awt.Font("Tahoma", 3, 14)); // NOI18N
        Title_jLabel.setText("Liste des Commandes Demandées par les Clients");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(155, 155, 155)
                .addComponent(Title_jLabel))
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 621, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(DetailsPlat_jPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(11, 11, 11)
                .addComponent(Title_jLabel)
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 219, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(11, 11, 11)
                .addComponent(DetailsPlat_jPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(18, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>                        

    private void Preparer_jButtonActionPerformed(java.awt.event.ActionEvent evt) {                                                 
        
        try {
            parentMainApp.cuisinier.send(new Message("CommencerPreparerPlat", parentMainApp.cuisinier.getUsername(), "CommencerPreparerPlat", "SERVER",Temp_Commande));
            
            CommandeDemandees_jTable.getSelectionModel().clearSelection();
            Categorie_jComboBox.setSelectedIndex(0);
            Nom_jTextField.setText("");
            Prix_jTextField.setText("");
            duree_jTextField.setText("");
            Image_jTextField.setText("");
            BX.setIcon(null);
            Quantite_jTextField.setText("");
            
            //RefreshProgressBar_Thread RefreshProgressBar_Thread_Temp = new RefreshProgressBar_Thread(parentMainApp, Temp_Commande);
                
            
        }catch(Exception ex){
            ex.printStackTrace();
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Erreur", JOptionPane.ERROR_MESSAGE);
        }
    }                                                

    private void CommandeDemandees_jTableKeyPressed(java.awt.event.KeyEvent evt) {                                                    
        SelectAction();
    }                                                   

    private void CommandeDemandees_jTableMouseClicked(java.awt.event.MouseEvent evt) {                                                      
        SelectAction();
    }                                                     

    private void CommandeDemandees_jTableMousePressed(java.awt.event.MouseEvent evt) {                                                      
        SelectAction();
    }                                                     
    
    public void SelectAction()
    {
        try {
            BX.setIcon(null);
            Selected_Row = CommandeDemandees_jTable.getSelectedRow();
            //System.out.println(String.valueOf(Selected_Row));
            Temp_Commande = parentMainApp.listeCommandeDemandes_Cuisinier.get(Selected_Row);
            
            Selected_categorie = Temp_Commande.getCommandePlat().getCategorie();
            Selected_nom = Temp_Commande.getCommandePlat().getNom();
            Selected_prix = Temp_Commande.getCommandePlat().getPrix();
            Selected_duree = Temp_Commande.getCommandePlat().getDuree();
            Selected_nom_image = Temp_Commande.getCommandePlat().getNom_image();
            Selected_image = Temp_Commande.getCommandePlat().getImage();


            Categorie_jComboBox.setSelectedItem(Selected_categorie);
            Nom_jTextField.setText(Selected_nom);
            Prix_jTextField.setText(""+Selected_prix);
            duree_jTextField.setText(""+Selected_duree);
            Image_jTextField.setText("./images/"+Selected_nom_image);
            Quantite_jTextField.setText(String.valueOf(Temp_Commande.getQuantite()));
            
            Selected_FilePath = "./images/"+Selected_nom_image;
            if(ArchOS){ Selected_FilePath = Selected_FilePath.replace("\\", "/"); }
            Selected_File = new File(Selected_FilePath);
            
            int blobLength = (int) Selected_image.length();
            Selected_bytes = Selected_image.getBytes(1, blobLength);
            
            ByteArrayInputStream in = new ByteArrayInputStream(Selected_bytes);
            FileOutputStream out = new FileOutputStream(Selected_File);
            IOUtils.copy(in, out);
            IOUtils.closeQuietly(in);
            IOUtils.closeQuietly(out);
            

                BufferedImage image;
                image = ImageIO.read(Selected_File);
                if(image == null) System.out.println("image null");
                ImageIcon icon;
                icon = new ImageIcon(image);
                
                
                
                Image img = icon.getImage();
                BufferedImage bi = new BufferedImage(img.getWidth(null), img.getHeight(null), BufferedImage.TYPE_INT_ARGB);
                Graphics g = bi.createGraphics();
                g.drawImage(img, 0, 0, 250, 215, null);
                ImageIcon newIcon = new ImageIcon(bi);

                BX.setIcon(newIcon);


                } catch (SQLException | IOException ex) {
                    ex.printStackTrace();
                }
    }
    
    int Selected_Row;
    String Selected_categorie;
    String Selected_nom;
    double Selected_prix;
    int Selected_duree;
    String Selected_nom_image;
    Blob Selected_image;
    String Selected_FilePath;
    File Selected_File;
    byte[] Selected_bytes;
    Commande Temp_Commande;
    
    boolean ArchOS = System.getProperty("os.name").startsWith("Windows");
    
    
    // Variables declaration - do not modify                     
    private javax.swing.JLabel BX;
    private javax.swing.JComboBox Categorie_jComboBox;
    private javax.swing.JLabel Categorie_jLabel;
    private javax.swing.JPanel DetailsPlat_jPanel;
    private javax.swing.JLabel Image_jLabel;
    private javax.swing.JPanel Image_jPanel;
    private javax.swing.JTextField Image_jTextField;
    private javax.swing.JLabel Nom_jLabel;
    private javax.swing.JTextField Nom_jTextField;
    private javax.swing.JButton Preparer_jButton;
    private javax.swing.JLabel Prix_jLabel;
    private javax.swing.JTextField Prix_jTextField;
    private javax.swing.JLabel Quantite_jLabel;
    private javax.swing.JTextField Quantite_jTextField;
    private javax.swing.JLabel Title_jLabel;
    private javax.swing.JLabel duree_jLabel;
    private javax.swing.JTextField duree_jTextField;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration                   

    
}
