package shared;

import java.io.Serializable;


public class Commande implements Serializable 
{
    private static final long serialVersionUID = 1L;
    
    private String nom_client;
    private int quantite,etat;
    private int ID_Commande=0;
    private Plat CommandePlat;
    
    private String ThreadName;
    private double TimePreparationinMiliSecond;
    private int ProgressValue=0;
    private int TempsEcoule=0;  //  milliseconde
    private long ClackRate;

    public Commande() {
    }
    
    
    public Commande(String nom_client, Plat plat, int quantite, int etat) {
        
        this.nom_client = nom_client;
        this.CommandePlat = plat;
        this.quantite = quantite;
        this.etat = etat;
    }

    public String getNom_client() {
        return nom_client;
    }

    public void setNom_client(String nom_client) {
        this.nom_client = nom_client;
    }

    public Plat getCommandePlat() {
        return CommandePlat;
    }

    public void setCommandePlat(Plat CommandePlat) {
        this.CommandePlat = CommandePlat;
    }

    

    public int getQuantite() {
        return quantite;
    }

    public void setQuantite(int quantite) {
        this.quantite = quantite;
    }

    public int getEtat() {
        return etat;
    }

    public void setEtat(int etat) {
        this.etat = etat;
    }

    public int getID_Commande() {
        return ID_Commande;
    }

    public void setID_Commande(int ID_Commande) {
        this.ID_Commande = ID_Commande;
    }

    public String getThreadName() {
        return ThreadName;
    }

    public void setThreadName(String ThreadName) {
        this.ThreadName = ThreadName;
    }

    public double getTimePreparationinMiliSecond() {
        return TimePreparationinMiliSecond;
    }

    public void setTimePreparationinMiliSecond(double TimePreparationinMiliSecond) {
        this.TimePreparationinMiliSecond = TimePreparationinMiliSecond;
    }

    public int getProgressValue() {
        return ProgressValue;
    }

    public void setProgressValue(int ProgressValue) {
        this.ProgressValue = ProgressValue;
    }

    public int getTempsEcoule() {
        return TempsEcoule;
    }

    public void setTempsEcoule(int TempsEcoule) {
        this.TempsEcoule = TempsEcoule;
    }

    public long getClackRate() {
        return ClackRate;
    }

    public void setClackRate(long ClackRate) {
        this.ClackRate = ClackRate;
    }

    @Override
    public String toString() {
        return "Commande{" + "nom_client=" + nom_client + ", quantite=" + quantite + ", etat=" + etat + ", ID_Commande=" + ID_Commande + ", CommandePlat=" + CommandePlat + ", ThreadName=" + ThreadName + ", TimePreparationinMiliSecond=" + TimePreparationinMiliSecond + ", ProgressValue=" + ProgressValue + ", TempsEcoule=" + TempsEcoule + ", ClackRate=" + ClackRate + '}';
    }
    
    
    
    
    
}
