package util;

import java.io.File;
import org.apache.commons.io.FileUtils;

public class FileConnect
{
  public String host;
  public String port;
  public ServerConnexion MainServer;
  
  public void write()
  {
    try
    {
      File file = new File("connect.config");
      
      String data = String.format("host=%s\r\nport=%s", new Object[] { this.host, this.port });
      FileUtils.writeStringToFile(file, data);
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }
  
  public ServerConnexion read()
  {
    try
    {
      File file = new File("connect.config");
      if (file.exists())
      {
        String data = FileUtils.readFileToString(file);
        String[] row = data.split("\r\n");
        
        this.host = row[0].replace("host=", "");
        this.port = row[1].replace("port=", "");
        
        MainServer = new ServerConnexion(host, port);
         
        return MainServer;
      }
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
    return null;
  }
}
