package shared;

import java.io.Serializable;
import java.sql.Blob;

public class Plat implements Serializable {
	
	private static final long serialVersionUID = 1L;
        
	private String categorie;
        private String nom;
        private double prix;
        private int duree;
        private String nom_image;
        private Blob image;
	
    public Plat(){}

    public Plat(String categorie, String nom, double prix, int duree, String nom_image, Blob image) {
        this.categorie = categorie.trim();
        this.nom = nom.trim();
        this.prix = prix;
        this.duree = duree;
        this.nom_image = nom_image;
        this.image = image;
    }

    @Override
    public String toString() {
        return "Plat{" + "categorie=" + categorie + ", nom=" + nom + ", prix=" + prix + ", duree=" + duree + ", nom_image=" + nom_image + ", image=" + image.toString() + '}';
    }
        
    public String getCategorie() {
        return categorie;
    }

    public void setCategorie(String categorie) {
        this.categorie = categorie;
    }

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public double getPrix() {
        return prix;
    }

    public void setPrix(double prix) {
        this.prix = prix;
    }

    public int getDuree() {
        return duree;
    }

    public void setDuree(int duree) {
        this.duree = duree;
    }

    public Blob getImage() {
        return image;
    }

    public void setImage(Blob image) {
        this.image = image;
    }	

    public String getNom_image() {
        return nom_image;
    }

    public void setNom_image(String nom_image) {
        this.nom_image = nom_image;
    }
    
}
